/*  This file is part of DropGather.

  DropGather is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  DropGather is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with DropGather.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <NIDAQmx.h>
#include "errorhandlers.h"

void DAQError(int32 error)
{
	if(error != 0)
	{
		char * msg;
		int32 size = DAQmxGetErrorString(error,NULL,0);
		if(size > 0)
		{
            msg = new char[size];
		}
		else
		{
			msg = new char[512];
			size = 512;
		}
		DAQmxGetErrorString(error, msg, size);
		Excpt expt(error, msg);
		delete [] msg;
		throw expt;
	}
};