/*  This file is part of DropGather.

  DropGather is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  DropGather is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with DropGather.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "imeProject.h"
#include <iostream>
#include <conio.h>

int main(int argc, char * argv)
{	
	std::stringstream proc;
	std::string input;
	bool fail1 = false;
	bool PbAg = false;
	bool Fill = false;
	bool Finish = false;  // osp or enig, osp is false
	bool rockandroll = false;

	bool cfgfail = false;
	bool cfgsolder = false;
	bool cfgfill = false;
	bool cfgfinish = false;

   // TODO make CLI parameters for these
   bool preconf = false;
   int boardnum = 0;

   const int chancount = 17;
   const int samplecount = 50000;  // approx:  1 s = 50000, 2s = 100000, 0.5s = 25000


   // preconfiguring
   cfgfail = true; // leave not 1fail
   cfgsolder = true; // leave not lead
   Finish = true; // osp
   cfgfinish = true; // leave all osp

   /* setup new configuration questions and base filename config, using only
   board number and underfill flag
   
   base filename should be used with drop counter combined later at file creation
   */

	try
	{
		bool quit = false;
		imeProject proj(chancount, samplecount); // Number of channels, number of samples

		while(!quit)
		{
			while(!rockandroll)
			{
				while(!cfgfail) // 1fail
				{
					std::cout << "Is this board marked 1-Fail? Y/[N]" << std::endl;
					std::getline(std::cin, input);
					if(input == "y" || input == "Y")
					{
						cfgfail = true;
						fail1 = true;
						break;
					}
					else if(input == "n" || input == "N" || input == "")
					{
						cfgfail = true;
						fail1 = false;
						break;
					}
					else
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
				}

				while(!cfgsolder)
				{
					std::cout << "Is this board lead? Y/[N]" << std::endl;
					std::getline(std::cin, input);
					if(input == "y" || input == "Y")
					{
						cfgsolder = true;
						PbAg = true;
						break;
					}
					else if(input == "n" || input == "N" || input == "")
					{
						cfgsolder = true;
						PbAg = false;
						break;
					}
					else
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
				}

				while(!cfgfill)
				{
					std::cout << "Is this board underfilled? Y/[N]" << std::endl;
					std::getline(std::cin, input);
					if(input == "y" || input == "Y")
					{
						cfgfill = true;
						Fill = true;
						break;
					}
					else if(input == "n" || input == "N" || input == "")
					{
						cfgfill = true;
						Fill = false;
						break;
					}
					else
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
				}

				while(!cfgfinish)
				{
					std::cout << "Is this board finish OSP? Y/[N]" << std::endl;
					std::getline(std::cin, input);
					if(input == "y" || input == "Y")
					{
						cfgfinish = true;
						Finish = true;
						break;
					}
					else if(input == "n" || input == "N" || input == "")
					{
						cfgfinish = true;
						Finish = false;
						break;
					}
					else
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
				}

				while(!boardnum) // dont ask about board number if it is already set
				{
					std::cout << "What is the board number?" << std::endl;
					std::getline(std::cin, input);
					proc.clear();
					proc.str("");
					proc.str(input);

					proc >> boardnum;

					if(proc.fail())
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
					break;
				};

				std::cout << "Board is one fail: ";
				if(fail1)
				{
					std::cout << "Yes";
				}
				else
				{
					std::cout << "No";
				}
				std::cout << std::endl;

				std::cout << "Solder paste is:   ";
				if(PbAg)
					std::cout << "Pb";
				else
					std::cout << "Lf";
				std::cout << std::endl;

				std::cout << "Board is filled:   ";
				if(Fill)
					std::cout << "Yes";
				else
					std::cout << "No";
				std::cout << std::endl;

				std::cout << "Board finish is:   ";
				if(Finish)
					std::cout << "OSP";
				else
					std::cout << "ENIG";
				std::cout << std::endl;

				std::cout << "Board number is:    ";
				std::cout << boardnum << std::endl << std::endl;

				while(1)
				{
					std::cout << "Is everything correct? Y/[N]" << std::endl;
					std::getline(std::cin, input);
					if(input == "y" || input == "Y")
					{
						rockandroll = true;
						break;
					}
					else if(input == "n" || input == "N" || input == "")
					{
						rockandroll = false;
                  // unset all preconf flags
                  cfgfail = cfgsolder = cfgfill = cfgfinish = false; // requery all config
                  boardnum = 0; // cause requery for board number
						break;
					}
					else
					{
						std::cout << "I didn't understand your response, try again." << std::endl;
						continue;
					}
				}
			}

         /* run the configured cycle */
			proj.doCase(fail1, PbAg, Fill, Finish, boardnum);
			rockandroll = false;


			while(1)
			{
				std::cout << "Is there another case? [Y]/N" << std::endl;
				std::getline(std::cin, input);
				if(input == "y" || input == "Y")
				{
					quit = false;
					break;
				}
				else if(input == "n" || input == "N" || input == "")
				{
					quit = true;
					break;
				}
				else
				{
					std::cout << "I didn't understand your response, try again." << std::endl;
					continue;
				}
			}
		}
	} catch (Excpt & error)
	{
		std::cout << error.emsg << std::endl;
	}

	std::cout << "Exiting..." << std::endl;

	return 0;
}