/*  This file is part of DropGather.

  DropGather is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  DropGather is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with DropGather.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "DataCollection.h"
#include "taskhandler.h"
#include <fstream>
#include <iostream>
#include <sstream>
#include <vector>
#include "dislin.h"

#ifndef IMEPROJ
#define IMEPROJ

class imeProject
{
	TaskHandler  taskHandle;
	int32       read;
	const int nSamples;
	const int nChans;
	int drop;
	DataCollection data;
	float * chan;
	float * tarray;

	imeProject() : nSamples(0), nChans(0), data(0,0) {};

	std::fstream db;
	std::fstream datafile;
	std::stringstream proc;
public:
	imeProject(int, int);
	~imeProject();
	void doCase(bool fail1, bool PbAg, bool Fill, bool Finish, int index);
	void imeProject::showCurveWnd(const int index);
};

#endif //IMEPROJ