/*  This file is part of DropGather.

  DropGather is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  DropGather is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with DropGather.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "NIDAQmx.h"
#include "errorhandlers.h"

#ifndef TASKHANDLER
#define TASKHANDLER

class TaskHandler
{
	TaskHandler(TaskHandler & copy) {};
	TaskHandler operator = (TaskHandler & copy) {};
	TaskHandle  taskHandle;
	std::string name;
public:
	TaskHandler() : taskHandle(0), name("")
	{
		char cname[100];
		DAQError(DAQmxCreateTask("",&taskHandle));
		DAQError(DAQmxGetTaskName(taskHandle, cname, 100));
		name = cname;
	};

	TaskHandler(const char * cname)
	{
		char cname2[100];
		DAQError(DAQmxCreateTask(cname,&taskHandle));
		DAQError(DAQmxGetTaskName(taskHandle, cname2, 100));
		name = cname2;
	};

	operator TaskHandle()
	{
		return taskHandle;
	}

	~TaskHandler()
	{
		if( taskHandle!=0 ) {
		/*********************************************/
		// DAQmx Stop Code
		/*********************************************/
		DAQmxStopTask(taskHandle);
		DAQmxClearTask(taskHandle);
		}
	}
};
#endif